
#ifndef __I8080_H__
#define __I8080_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
//WX^̔ԍ
#define I8080_REG_B						0
#define I8080_REG_C						1
#define I8080_REG_D						2
#define I8080_REG_E						3
#define I8080_REG_H						4
#define I8080_REG_L						5
#define I8080_REG_M						6
#define I8080_REG_A						7


//WX^̃tOʒu
#define I8080_FLG_CARRY					0x01
#define I8080_FLG_BIT1					0x02
#define I8080_FLG_PARITY				0x04
#define I8080_FLG_BIT3					0x08
#define I8080_FLG_CY4					0x10
#define I8080_FLG_SUB					0x20
#define I8080_FLG_ZERO					0x40
#define I8080_FLG_SIGN					0x80


//---------------------------------------------------------------------------

typedef struct {
	//WX^
	u8   reg[8];
	u16  regPC;
	u16  regSP;
	u8   flgPSW;

	//샂[h
	bool isDaaSub;						//ZDAAs̃tO
	bool isIllInst;						//s߂̃gbv
	u16  addrMask;						//sANZXop̃AhX}XN
	u16  scanRate;						//bNlƂ̖ߎs
	u16  scanIdle;						//bNlƂ̃ACh

	//n[hEFAMȂ
	bool isReset;						//ZbgMtO
	bool isIntEnable;					//荞݃Cl[uMtO
	bool isIntFF;						//IRQMxpF/FtO
	bool isIntIRQ;						//荞݃NGXgtO
	bool isProtect;						//veNgSW
	bool isSingleStep;					//VOXebvSW

} ST_I8080;


typedef struct {
	void (*pFunc)(u8);
} ST_I8080_OP_TABLE;


//---------------------------------------------------------------------------
IWRAM_CODE void I8080Init();
IWRAM_CODE void I8080Reset();
IWRAM_CODE void I8080Exec();


//ʏ
IWRAM_CODE u8   I8080GetAtPC();
IWRAM_CODE u16  I8080GetReg16(u8 regH, u8 regL);
IWRAM_CODE void I8080SetReg16(u8 regH, u8 regL, u16 data);
IWRAM_CODE u8   I8080GetReg8(u8 regNum);
IWRAM_CODE void I8080SetReg8(u8 regNum, u8 val);

IWRAM_CODE u8   I8080MemRead(u16 addr);
IWRAM_CODE void I8080MemWrite(u16 addr, u8 val);

IWRAM_CODE void I8080OpSetFlag(u8 data);
IWRAM_CODE void I8080OpAdd(u16 t1, u16 t2, u16 c);
IWRAM_CODE u8   I8080OpSub(u16 t1, u16 t2, u16 c);


//ߎs[`
IWRAM_CODE void I8080Undef(u8 op);
IWRAM_CODE void I8080Nop(u8 op);
IWRAM_CODE void I8080Lxi(u8 op);
IWRAM_CODE void I8080Stax(u8 op);
IWRAM_CODE void I8080Inx(u8 op);
IWRAM_CODE void I8080Inr(u8 op);
IWRAM_CODE void I8080Dcr(u8 op);
IWRAM_CODE void I8080Rlc(u8 op);
IWRAM_CODE void I8080Rrc(u8 op);
IWRAM_CODE void I8080Ral(u8 op);
IWRAM_CODE void I8080Rar(u8 op);
IWRAM_CODE void I8080Mvi(u8 op);
IWRAM_CODE void I8080Dad(u8 op);
IWRAM_CODE void I8080Ldax(u8 op);
IWRAM_CODE void I8080Dcx(u8 op);
IWRAM_CODE void I8080Sta(u8 op);
IWRAM_CODE void I8080Lda(u8 op);
IWRAM_CODE void I8080Shld(u8 op);
IWRAM_CODE void I8080Lhld(u8 op);
IWRAM_CODE void I8080Cma(u8 op);
IWRAM_CODE void I8080Stc(u8 op);
IWRAM_CODE void I8080Cmc(u8 op);
IWRAM_CODE void I8080Daa(u8 op);
IWRAM_CODE void I8080Xchg(u8 op);
IWRAM_CODE void I8080Xthl(u8 op);
IWRAM_CODE void I8080Sphl(u8 op);
IWRAM_CODE void I8080Pchl(u8 op);
IWRAM_CODE void I8080Mov(u8 op);
IWRAM_CODE void I8080Hlt(u8 op);
IWRAM_CODE void I8080Add(u8 op);
IWRAM_CODE void I8080Adc(u8 op);
IWRAM_CODE void I8080Adi(u8 op);
IWRAM_CODE void I8080Sub(u8 op);
IWRAM_CODE void I8080Sbb(u8 op);
IWRAM_CODE void I8080Sbi(u8 op);
IWRAM_CODE void I8080Ana(u8 op);
IWRAM_CODE void I8080Xra(u8 op);
IWRAM_CODE void I8080Ora(u8 op);
IWRAM_CODE void I8080Cmp(u8 op);
IWRAM_CODE void I8080Ani(u8 op);
IWRAM_CODE void I8080Xri(u8 op);
IWRAM_CODE void I8080Ori(u8 op);
IWRAM_CODE void I8080Cpi(u8 op);
IWRAM_CODE void I8080Ret(u8 op);
IWRAM_CODE void I8080Call(u8 op);
IWRAM_CODE void I8080Push(u8 op);
IWRAM_CODE void I8080Pop(u8 op);
IWRAM_CODE void I8080Jmp(u8 op);
IWRAM_CODE void I8080InOut(u8 op);
IWRAM_CODE void I8080DiEi(u8 op);
IWRAM_CODE void I8080Rst(u8 op);


//̑
IWRAM_CODE void I8080Trace();


#ifdef __cplusplus
}
#endif
#endif
