
#include "inc.h"
#include "minix.h"

#include "tk80.h"
#include "i8255.h"

//---------------------------------------------------------------------------
ST_I8255 I8255;

//---------------------------------------------------------------------------
EWRAM_CODE void I8255Init()
{
	_Memset((u8*)&I8255, 0x00, sizeof(ST_I8255));
}
//---------------------------------------------------------------------------
EWRAM_CODE void I8255Reset()
{
	ST_I8255* p  = &I8255;

	//[h0AׂẴ|[g͓
	p->regCtrl = 0x9b;
	p->portA   = 0xff;
	p->portB   = 0xff;
	p->portC   = 0xff;
}
//---------------------------------------------------------------------------
EWRAM_CODE void I8255Out(u8 addr, u8 val)
{
	ST_I8255* p = &I8255;

	switch (addr)
	{
	case 0xf8: p->portA = val; break;
	case 0xf9: p->portB = val; break;
	case 0xfa: p->portC = val; break;

	case 0xfb:

		if(val & 0x80)
		{
			//[hݒ
			p->regCtrl = val;
		}
		else
		{
			//rbgZbg/Zbg
			u8 bit = 0x00;

			switch (val & 0x0e)
			{
			case 0x00: bit = 0x01; break;
			case 0x02: bit = 0x02; break;
			case 0x04: bit = 0x04; break;
			case 0x06: bit = 0x08; break;
			case 0x08: bit = 0x10; break;
			case 0x0a: bit = 0x20; break;
			case 0x0c: bit = 0x40; break;
			case 0x0e: bit = 0x80; break;
			}

			if(val & 0x01)
			{
				p->portC |=  bit;
			}
			else
			{
				p->portC &= ~bit;
			}
		}
		break;

	}	// switch addr
}
//---------------------------------------------------------------------------
EWRAM_CODE u8 I8255In(u8 addr)
{
	ST_I8255* p = &I8255;

	//L[}gNX擾܂BportAɏ݂܂B
	Tk80UpdateKey();

	switch (addr)
	{
	case 0xf8:
		return p->portA;
	case 0xf9:
		return p->portB;
	case 0xfa:
		return p->portC;
	case 0xfb:
		return 0x0ff;
	}

	return 0x00;
}
